/*
 * include/brocade/silkworm_hwsem.h
 *
 * Brocade Silkworm platform hw sem definitions
 *
 */

#ifndef __SILKWORM_HWSEM_H__
#define __SILKWORM_HWSEM_H__

#include <linux/types.h>

#define SILKWORM_HWSEM_RESET_CAPABLE	0x1
#define SILKWORM_HWSEM_RESET_AT_BOOT	0x2

#define SILKWORM_HWSEM_MAX				8

#define	SILKWORM_HWSEM_STATE_INVALID			1
#define	SILKWORM_HWSEM_STATE_NOT_LOCKED			2
#define	SILKWORM_HWSEM_STATE_LOCKED_BY_THIS_CPU		3
#define	SILKWORM_HWSEM_STATE_LOCKED_BY_OTHER_CPU	4
	
extern int silkworm_hwsem_trylock(unsigned char);
extern int silkworm_hwsem_unlock(unsigned char);
extern int silkworm_hwsem_get_status(unsigned char, int *);
extern int silkworm_hwsem_reset(unsigned char);

#endif /* __SILKWORM_HWSEM_H__ */
